openapi: 3.0.1
info:
  title: OMS
  contact:
    name: API Support
    url: https://ensi.tech/contacts
    email: mail@greensight.ru
  version: 1.0.0
  description: Управление заказами
servers:
  - url: /api/v1
tags:
  ### DOMAIN ORDERS ###
  - name: deliveries
    description: Управление отправлениями
  - name: orders
    description: Управление заказами
  - name: order_items
    description: Управление составом заказа
  - name: shipments
    description: Управление отгрузками

  ### DOMAIN PAYMENT SYSTEM ###
  #  - name: example
  #    description: example

  ### DOMAIN COMMON ###
  - name: common
    description: Управление параметрами
  - name: enums
    description: Управление перечислениями

  ### DOMAIN REFUNDS ###
  - name: refunds
    description: Управление заявками на возврат
paths:
  ### DOMAIN ORDERS ###

  # tag deliveries
  /orders/deliveries:search:
    $ref: './orders/paths.yaml#/DeliveriesSearch'
  /orders/deliveries/{id}:
    $ref: './orders/paths.yaml#/DeliveriesOne'

  # tag order_items
  /orders/orders/{id}:add-order-items:
    $ref: './orders/paths.yaml#/OrderItemsAdd'
  /orders/orders/{id}:delete-order-items:
    $ref: './orders/paths.yaml#/OrderItemsDelete'
  /orders/orders/{id}:change-order-items-qty:
    $ref: './orders/paths.yaml#/OrderItemOneChangeQty'

  # tag orders
  /orders/orders:search:
    $ref: './orders/paths.yaml#/OrdersSearch'
  /orders/orders/{id}:
    $ref: './orders/paths.yaml#/OrdersOne'
  /orders/orders/{id}:start-payment:
    $ref: './orders/paths.yaml#/OrdersOneStartPayment'
  /orders/orders/{id}:check-payment: # todo покрыть тестами после реализации какой-нибудь системы поддерживающей этот метод
    $ref: './orders/paths.yaml#/OrdersOneCheckPayment'
  /orders/orders/{id}:change-payment-method:
    $ref: './orders/paths.yaml#/OrdersOneChangePaymentMethod'
  /orders/orders/{id}:change-delivery:
    $ref: './orders/paths.yaml#/OrderOneChangeDelivery'
  /orders/orders/{id}:comment:
    $ref: './orders/paths.yaml#/OrdersOneComment'
  /orders/orders:commit:
    $ref: './orders/paths.yaml#/OrdersCommit'
  /orders/orders/{id}:attach-file:
    $ref: './orders/paths.yaml#/OrdersOneAttachFile'
  /orders/orders/{id}:delete-files:
    $ref: './orders/paths.yaml#/OrdersOneDeleteFiles'

  # tag shipments
  /orders/shipments:search:
    $ref: './orders/paths.yaml#/ShipmentsSearch'
  /orders/shipments/{id}:
    $ref: './orders/paths.yaml#/ShipmentsOne'

  ### DOMAIN SETTINGS ###

  # tag common
  /common/settings:
    $ref: './common/paths.yaml#/SettingsList'
  /common/customer-personal-data:check-conditions-to-delete:
    $ref: './common/paths.yaml#/CheckConditionsToDeleteCustomerPersonalData'
  /common/customer-personal-data:delete:
    $ref: './common/paths.yaml#/DeleteCustomerPersonalData'

  ### DOMAIN REFUNDS ###

  # tag refunds
  /refunds/refunds:
    $ref: './refunds/paths.yaml#/Refund'
  /refunds/refunds:search:
    $ref: './refunds/paths.yaml#/RefundsSearch'
  /refunds/refunds/{id}:
    $ref: './refunds/paths.yaml#/RefundsOne'
  /refunds/refunds/{id}:attach-file:
    $ref: './refunds/paths.yaml#/RefundOneAttachFile'
  /refunds/refunds/{id}:delete-files:
    $ref: './refunds/paths.yaml#/RefundDeleteFiles'

  #tag enums
  /refunds/refund-reasons:
    $ref: './refunds/paths.yaml#/RefundReasons'
  /refunds/refund-reasons/{id}:
    $ref: './refunds/paths.yaml#/RefundReasonsOne'

components:
  schemas:
    PaginationTypeEnum:
      $ref: './common_schemas.yaml#/PaginationTypeEnum'
    OrderStatusEnum:
      $ref: './orders/enums/order_status_enum.yaml'
    OrderSourceEnum:
      $ref: './orders/enums/order_source_enum.yaml'
    RefundStatusEnum:
      $ref: './refunds/enums/refund_status_enum.yaml'
    DeliveryStatusEnum:
      $ref: './orders/enums/delivery_status_enum.yaml'
    ShipmentStatusEnum:
      $ref: './orders/enums/shipment_status_enum.yaml'
    PaymentMethodEnum:
      $ref: './orders/enums/payment_method_enum.yaml'
    PaymentStatusEnum:
      $ref: './orders/enums/payment_status_enum.yaml'
    CountryCodeEnum:
      $ref: './orders/enums/country_code_enum.yaml'
    PaymentSystemEnum:
      $ref: './payment_systems/enums/payment_system_enum.yaml'
    SettingCodeEnum:
      $ref: './common/enums/setting_code_enum.yaml'
    EmptyDataResponse:
      type: object
      properties:
        data:
          type: object
          nullable: true
        meta:
          type: object
      required:
        - data
  responses:
    BadRequest:
      description: Bad Request
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
    NotFound:
      description: Not Found
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
    ServerError:
      description: Internal Server Error
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
